//---------------------------------------------------------------------------

#ifndef SlideJmpPanelH
#define SlideJmpPanelH
//---------------------------------------------------------------------------
#include <SysUtils.hpp>
#include <Controls.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------

const String Version = "1.00" ;
const int CenterMargin = 2 ;
const int HandleWidth = 8 ;
const int SliderWidth = 4 ;

class PACKAGE TSlideJmpPanel : public TPanel
{

private:
      typedef enum {spHidden, spMiddle, spFull } TPanelState ;
      typedef enum {hpLeft, hpRight, hpTop , hpBottom } THandlePosition ;


      TPanel *FHP ;       // Handle panel
      TImage *LeftArr ;   // Left Arrow image
      TImage *RightArr;   // Right Arrow image
      TImage *UpArr   ;
      TImage *DownArr ;
      TPoint FPT      ;   // mouse down point
      TPoint FOF      ;   // Offset from left and top of mouse down point
      int    FMN      ;   // Minimum size for current drag
      int    FMX      ;   // Maximum size for current drag
      int    HorPnlWidth ;
      int    VerPnlHeight;

      THandlePosition FHandlePos  ;
      int  FMinSize ;
      int  FMaxSize ;
      bool FHandleVisible ;
      bool FJmpHandleVisible ;
      String FVersion ;
      TPanelState spnlState ;
      bool Start ;


      void __fastcall MouseDownOnHandle(TObject *Sender , TMouseButton Button ,
           TShiftState Shift , int X, int Y ) ;

      void __fastcall MouseUpOnHandle(TObject *Sender , TMouseButton Button ,
           TShiftState Shift , int X, int Y ) ;

      void __fastcall MouseMoveOnHandle(TObject *Sender , TShiftState Shift , int X, int Y) ;

      void __fastcall LeftArrMouseClick(TObject *Sender) ;
      void __fastcall RightArrMouseClick(TObject *Sender) ;
      void __fastcall UpArrMouseClick(TObject *Sender) ;
      void __fastcall DownArrMouseClick(TObject *Sender) ;

      DYNAMIC void __fastcall Resize(void) ;   // Resize for TSlideJmpPanel

      int __fastcall DefaultMinSize(void) ;
      void __fastcall SetHandlePos(THandlePosition NewPos) ;
      void __fastcall SetHandleVisible(bool NewVis) ;
      void __fastcall SetJmpHandleVisible(bool NewHandleVis) ;
      void __fastcall UpdateHandlePanel(void) ;

protected:
      TWndMethod OldWndProc;
      TComponent *Ow ;
      
      virtual void __fastcall MyWndProc(TMessage &Message) ;

public:
        __fastcall TSlideJmpPanel(TComponent* Owner);
        __fastcall ~TSlideJmpPanel(void) ;
        int ParClientHeight, ParClientWidth ;
        bool ResizeDue2Jmp , ResizeDue2Drag , ClientResize ;


__published:
    __property THandlePosition HandlePosition = {read=FHandlePos , write=SetHandlePos} ;
    __property int MinSize = {read = FMinSize , write = FMinSize} ;
    __property int MaxSize = {read = FMaxSize , write = FMaxSize} ;
    __property bool HandleVisible = {read = FHandleVisible, write=SetHandleVisible} ;
    __property String Version = {read=FVersion} ;
    __property bool JmpHandleVisible={read=FJmpHandleVisible , write=SetJmpHandleVisible} ;

};
//---------------------------------------------------------------------------
#endif
